【BZOJ】2020: [Usaco2010 Jan]Buying Feed, II (dp)

http://www.lydsy.com/JudgeOnline/problem.php?id=2020

和背包差不多

同样滚动数组

f[j]表示当前位置j份食物的最小价值

f[j]=min(f[j-l]+l*c) 1<=l<=f

而且在每一步走的时候

f[j]+=j

然后就行了。。

#include <cstdio>
#include <cstring>
#include <cmath>
#include <string>
#include <iostream>
#include <algorithm>
#include <queue>
using namespace std;
#define rep(i, n) for(int i=0; i<(n); ++i)
#define for1(i,a,n) for(int i=(a);i<=(n);++i)
#define for2(i,a,n) for(int i=(a);i<(n);++i)
#define for3(i,a,n) for(int i=(a);i>=(n);--i)
#define for4(i,a,n) for(int i=(a);i>(n);--i)
#define CC(i,a) memset(i,a,sizeof(i))
#define read(a) a=getint()
#define print(a) printf("%d", a)
#define dbg(x) cout << #x << " = " << x << endl
#define printarr(a, n, m) rep(aaa, n) { rep(bbb, m) cout << a[aaa][bbb]; cout << endl; }
inline const int getint() { int r=0, k=1; char c=getchar(); for(; c<'0'||c>'9'; c=getchar()) if(c=='-') k=-1; for(; c>='0'&&c<='9'; c=getchar()) r=r*10+c-'0'; return k*r; }
inline const int max(const int &a, const int &b) { return a>b?a:b; }
inline const int min(const int &a, const int &b) { return a<b?a:b; }

const int N=105, K=105, E=400;
int n, k, e;
int f[K];
struct dat { int x, f, c; }a[N];

int main() {
	read(k); read(e); read(n);
	for1(i, 1, n) read(a[i].x), read(a[i].f), read(a[i].c);
	CC(f, 0x3f); f[0]=0;
	for1(p, 0, e) {
		for1(j, 1, k) f[j]+=j;
		for1(i, 1, n) if(a[i].x==p) {
			for3(j, k, 1) {
				for1(l, 1, a[i].f) if(j-l>=0)
					f[j]=min(f[j], f[j-l]+l*a[i].c);
			}
		}
	}
	print(f[k]);
	return 0;
}

噗,看了题解后是贪心。。自己想想也是显然啊。。

如果在这个商店买了后,一直要运到终点啊,所以将物品全部拆开后算距离然后贪心取就行了。。

 

 


 

 

Description

(buying.pas/buying.in/buying.out 128M 1S) Farmer John needs to travel to town to pick up K (1 <= K <= 100) pounds of feed. Driving D miles with K pounds of feed in his truck costs D*K cents. The county feed lot has N (1 <= N <= 100) stores (conveniently numbered 1..N) that sell feed. Each store is located on a segment of the X axis whose length is E (1 <= E <= 350). Store i is at location X_i (0 < X_i < E) on the number line and can sell FJ as much as F_i (1 <= F_i <= 100) pounds of feed at a cost of C_i (1 <= C_i <= 1,000,000) cents per pound. Amazingly, a given point on the X axis might have more than one store. FJ starts at location 0 on this number line and can drive only in the positive direction, ultimately arriving at location E, with at least K pounds of feed. He can stop at any of the feed stores along the way and buy any amount of feed up to the the store's limit. What is the minimum amount FJ has to pay to buy and transport the K pounds of feed? FJ knows there is a solution. Consider a sample where FJ needs two pounds of feed from three stores (locations: 1, 3, and 4) on a number line whose range is 0..5: 0 1 2 3 4 5 +---|---+---|---|---+ 1 1 1 Available pounds of feed 1 2 2 Cents per pound It is best for FJ to buy one pound of feed from both the second and third stores. He must pay two cents to buy each pound of feed for a total cost of 4. When FJ travels from 3 to 4 he is moving 1 unit of length and he has 1 pound of feed so he must pay 1*1 = 1 cents. When FJ travels from 4 to 5 he is moving one unit and he has 2 pounds of feed so he must pay 1*2 = 2 cents. The total cost is 4+1+2 = 7 cents. FJ开车去买K份食物,如果他的车上有X份食物。每走一里就花费X元。 FJ的城市是一条线,总共E里路,有E+1个地方,标号0~E。 FJ从0开始走,到E结束(不能往回走),要买K份食物。 城里有N个商店,每个商店的位置是X_i(一个点上可能有多个商店),有F_i份食物,每份C_i元。 问到达E并买K份食物的最小花费

Input

第1行:K,E,N 第2~N+1行:X_i,F_i,C_i.

Output

Sample Input


2 5 3
3 1 2
4 1 2
1 1 1

Sample Output


7

HINT

Source

posted @ 2014-09-14 16:32  iwtwiioi  阅读(362)  评论(0编辑  收藏  举报